
c action: replacement C05 subroutines for mark25
c author: w.g.bardsley, university of manchester, u.k., 10/07/2016 

c c05adf$ (not included)
c c05nbf$
c fcn_c05qbf 
c


C
C
      SUBROUTINE C05NBF$(FCN_C05NBF$, N, X, FVEC, XTOL, WA, LWA, IFAIL)
C
C ACTION : Version of NAG routine C05NBF
C AUTHOR : W.G.Bardsley, University of Manchester, U.K, 23/1/99
C          10/07/2016 replaced input subroutine FCN by FCN_C05NBF$ and now calls C05QBF
C                     but subroutine FCN_C05QBF passed to C05QBF now calls FCN_C05NBF$ at mark 25 
C
      IMPLICIT   NONE
      INTEGER    N, LWA, IFAIL
      INTEGER    IFLAG, IUSER(10)
      DOUBLE PRECISION X(N), FVEC(N), XTOL, WA(LWA)
      DOUBLE PRECISION ZERO
      PARAMETER (ZERO = 0.0D+00)
      DOUBLE PRECISION TOL
      EXTERNAL   FCN_C05NBF$, C05QBF, FCN_C05QBF
C
C Check input parameters
C
      IFAIL = 0
      IF (N.LE.0 .OR. XTOL.LT.ZERO) THEN
         IFAIL = 1
         RETURN
      ENDIF
      TOL = XTOL
      CALL FCN_C05NBF$(N, X, FVEC, IFLAG)
      IUSER(1) = 0
      WA(1) = 0.0D+00
      CALL C05QBF (FCN_C05QBF, N, X, FVEC, TOL, IUSER, WA, IFAIL)
      END
C
C
      SUBROUTINE FCN_C05QBF (N, X, FVEC, IUSER, RUSER, IFLAG)
      IMPLICIT NONE
      INTEGER  N, IUSER(*), IFLAG
      DOUBLE PRECISION X(N), FVEC(N), RUSER(*)
      EXTERNAL FCN_C05NBF$ 
      IF (IUSER(1).LE.0) THEN
         IUSER(1) = 1
         RUSER(1) = 1.0D+00
      ELSE
         IUSER(1) = IUSER(1) + 1   
      ENDIF   
      CALL FCN_C05NBF$ (N, X, FVEC, IFLAG)
      END
C
C
      